#include <stdio.h>
#include <pthread.h>
#include <errno.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define NUM_THREADS 100

struct sys_command_struct {
	char *cmd;
	char **output;
	int ret;
	int num_lines;
};

char **run_cmd(const char *, int *, int *);
inline int th_entry(struct sys_command_struct *);

int main()
{
	pthread_t th[NUM_THREADS];
	struct sys_command_struct scmd[NUM_THREADS];

	int i, result, x;

	for(i = 0; i < NUM_THREADS; i++) {
		scmd[i].cmd = "/bin/ls -l /etc/{passwd,shadow}";
		result = pthread_create(&th[i], NULL, (void *)th_entry, &scmd[i]);
		if(result != 0) {
			printf("thread create failure. thread: %d, errno: %d\n", i, errno);
		}
		else {
			result = pthread_join(th[i], NULL);
		}
	}

	for(i = 0; i < NUM_THREADS; i++) {
		printf("Command: %s\n", scmd[i].cmd);
		printf("Return: %d\n", scmd[i].ret);
		printf("Output (%d lines)::\n", scmd[i].num_lines);
		for(x = 0; x < scmd[i].num_lines; x++) {
			printf("%3d: %s\n", x, scmd[i].output[x]);
		}
	}

	return 0;
}

inline int th_entry(struct sys_command_struct *syscmd)
{
	syscmd->output = run_cmd(syscmd->cmd, &syscmd->ret, &syscmd->num_lines);
	return 0;
}

char **run_cmd(const char *cmd, int *cmd_ret, int *output_lines)
{
	FILE *p;
	size_t lines_allocated = 20, lineno = 0, len;
	char buf[1024];
	char **output;

	output = malloc(20 * sizeof(char *));

	p = popen(cmd, "r");
	while((fgets(buf, sizeof(buf), p))) {
		len = strlen(buf);
		if(buf[len - 1] == '\n') buf[len - 1] = '\0';
		while(lineno >= lines_allocated) {
			lines_allocated += 20;
			output = realloc(output, lines_allocated * sizeof(char *));
		}

		output[lineno++] = strdup(buf);
	}

	*cmd_ret = pclose(p);
	*output_lines = lineno;

	return output;
}
